#!/usr/bin/env python
import gobject
import ORBit
import CORBA

# Load the DAQcorba type library for the Observer.
ORBit.load_typelib('DAQcorba')
import DAQcorba__POA
from DAQcorba import DAQ

RunStates = {
    DAQ.NotDefined   : 'NotDefined',
    DAQ.NotReady     : 'NotReady',    
    DAQ.GettingReady : 'GettingReady',
    DAQ.Ready        : 'Ready',       
    DAQ.Starting     : 'Starting',    
    DAQ.Paused       : 'Paused',              
    DAQ.Running      : 'Running',     
    DAQ.Stopping     : 'Stopping',    
    DAQ.Stopped      : 'Stopped',     
    DAQ.TimeOut      : 'TimeOut'
    }

        
class Emitter(gobject.GObject):
    __gsignals__ = {
        'state_changed': (gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
                          (gobject.TYPE_STRING,))
        }
    def __init__(self):
        self.__gobject_init__() # default constructor using our new GType

    def do_state_changed(self,arg):
        pass
        # print 'state_changed',arg
        

gobject.type_register(Emitter)


class MyObserver(DAQcorba__POA.DAQ.Observer):
    """
    This is the Client observer that will receive the notifications of
    any change in the DAQ.
    """
   
    def __init__(self,daqm):
        super(MyObserver,self).__init__()
        self.daqm = daqm
        self.runm = daqm.findRunManager('main')
        self.emitter = Emitter()

    def connect(self,signal,handler,data):
        self.emitter.connect(signal,handler,data)
    
    def update(self,any):
        state = any.value()

        if state.val._d==DAQ.Unknown:
            print  "*** An unknown update"
            
        elif state.val._d==DAQ.ModuleAdded:
            print "*** ModuleAdded",state.val._v
            
        elif state.val._d==DAQ.RunManagerAdded:
            print "*** RunManagerAdded ",state.val._v
            self.runm= self.daqm.findRunManager('main')
            
        elif state.val._d==DAQ.ModuleRemoved:
            print "*** ModuleRemoved",state.val._v
            
        elif state.val._d==DAQ.RunManagerRemoved:
            print "*** RunManagerRemoved ",state.val._v
            self.runm=None
            
        elif state.val._d==DAQ.StateChanged:
            print "*** State changed ",state.val._v.id,':',state.id
            self.emitter.emit("state_changed",state.id)
            
        elif state.val._d==DAQ.ParameterChanged:
            print "*** ParameterChanged [",state.id,"]"

        else:
            print "*** Something went really wrong"

#----------------------------------------------------------------------
