#!/usr/bin/env python
import sys,os

import ORBit
import CORBA
import MyObserver
import HstData
import time
from threading import Thread

from references import find_daqpp_references
# Load the DAQcorba type library for the Observer.
ORBit.load_typelib('DAQcorba')
from DAQcorba import DAQ

def create_any(val):
    if isinstance(val, bool):
        return CORBA.Any(CORBA.TypeCode('IDL:omg.org/CORBA/boolean:1.0'),val)
    elif isinstance(val,int) or isinstance(val,long):
        return CORBA.Any(CORBA.TypeCode('IDL:omg.org/CORBA/long:1.0'),val)
    elif isinstance(val,float):
        return CORBA.Any(CORBA.TypeCode('IDL:omg.org/CORBA/float:1.0'),val)
    elif isinstance(val,str):
        return CORBA.Any(CORBA.TypeCode('IDL:omg.org/CORBA/string:1.0'),val)
    else:
        return CORBA.Any(CORBA.TypeCode('IDL:omg.org/CORBA/string:1.0'),str(val))

def main():
    # Init the orb
    orb = CORBA.ORB_init(sys.argv)

    # Find the references
    file = None
    for x in sys.argv[1:]:
        if x[0]!='-':
            file = x
            break

    daqm,observable = find_daqpp_references(orb,file)
    if not daqm or not observable:
        print 'Could not find the objects'
        print daqm,observable
        sys.exit(1)

    print 'List of Module:'
    Mid = daqm. listModuleIDs()
    print Mid

    print 'Parameters of the module'
    module=daqm.findModule(Mid[0])

    

    pl = module.getParamNames()
    print pl
    for p in pl:
        try:
            r = module.getParam(p)
            v = r.value();
            print p,r.typecode().repo_id,'->',v
        except CORBA.UserException,e:
            print e
    
    module.setParam('threshold', create_any(15), True)
if __name__ == '__main__':
    main()

#----------------------------------
