#!/usr/bin/env python

import ORBit
import CORBA
import string
import sys
import gobject
import MyObserver
import HstData

from references import find_daqpp_references


# Load the DAQcorba type library for the Observer.
ORBit.load_typelib('DAQcorba')
import DAQcorba__POA
import DAQcorba

loop = None

def keypress(src,cond):
    global loop
    print src,cond
    loop.quit()


def main():
    global loop
    
    orb = CORBA.ORB_init(sys.argv)
#    poa = orb.resolve_initial_references('RootPOA')
#    poa.the_POAManager.activate()
    
    daqm,observable = find_daqpp_references(orb)
    if not daqm or not observable:
        sys.exit(1)


    obs = MyObserver.MyObserver()
    obsref = obs._this()
    cb = observable.registerCallback( obsref )

    print 'Number of RunManagers:',daqm.countRunManagers()
    print 'Number of Modules:',daqm.countModules()
    Lid = daqm.listRunManagerIDs()
    print 'List of RunManagers\n',Lid

    print 'Parameters of main:'
    runm = daqm.findRunManager('main')
    
    pl = runm.getParamNames()
    for p in pl:

        r = runm.getParam(p)
        v = r.value();
        print p,r.typecode().repo_id,'->',v

    print 'List of Module:'
    Mid = daqm. listModuleIDs()
    print Mid

    print 'Parameters of the module'
    module=daqm.findModule(Mid[0])
    pl = module.getParamNames()
    print pl
    for p in pl:
        try:
            r = module.getParam(p)
            v = r.value();
            print p,r.typecode().repo_id,'->',v
        except CORBA.UserException,e:
            print e

##     print 'setting a parameter'
##     tc = CORBA.TypeCode('IDL:omg.org/CORBA/long:1.0')
##     any = CORBA.Any(tc,2L)
##     module.setParam('p_long',any,True)


##     try:
##         orb.run()
##     except KeyboardInterrupt:
##         pass

    

    gobject.io_add_watch(sys.stdin.fileno(),gobject.IO_IN ,keypress)
    loop = gobject.MainLoop()
    loop.run()            

    print 'Bye'
    observable.unregisterCallback(cb)
    print 'Shutting down the ORB'
    orb.shutdown(1)

if __name__=='__main__':
    main()
    
#-------------------------------------------------------------------------
