#!/usr/bin/env python

import sys
import os
import string
from distutils.core import setup, Extension
from distutils.sysconfig import get_config_vars,get_config_var
import distutils.sysconfig

if not os.path.isdir('vmedaq'):
    os.mkdir('vmedaq')

finp = open('__init__.py')
fout = open('vmedaq/__init__.py','w')
fout.write( finp.read() )
finp.close()
fout.close()

_forig = distutils.sysconfig._init_posix
def my_init_posix():
    print '*** _init_posix'
    _forig()
    g = get_config_vars()
#    g['OPT'] = g['OPT'].replace('-O2','-O3')
    g['OPT'] = g['OPT'].replace('-O2','')


distutils.sysconfig._init_posix=my_init_posix
  
def getoutput(cmd):
    """Return output (stdout or stderr) of executing cmd in a shell."""
    return getstatusoutput(cmd)[1]
 
def getstatusoutput(cmd):
    """Return (status, output) of executing cmd in a shell."""
    if sys.platform == 'win32':
        pipe = os.popen(cmd, 'r')
        text = pipe.read()
        sts = pipe.close() or 0
        if text[-1:] == '\n':
            text = text[:-1]
        return sts, text
    else:
        from commands import getstatusoutput
        return getstatusoutput(cmd)


cflags_l=getoutput('pkg-config glib-2.0 --cflags')
cflags=[ x.replace('-I','') for x in string.split(cflags_l) ]
cflags.insert(0,".")
cflags.append("../..")

libs_l=string.strip(getoutput('pkg-config glib-2.0 --libs'))
libs=[ x.replace('-l','') for x in string.split(libs_l) ]
libs.append("z")

print cflags
print libs

setup(name="py-vmedaq",
      version="0.5.3",
      description="Python helper to read vmedaq output files",
      author="Carlos Lacasta",
      author_email="Carlos.Lacasta@ific.uv.es",
      url="http://ific.uv.es/~lacasta",
      license='GPL',
      packages=["vmedaq"],
      ext_package="vmedaq",
      ext_modules=[ Extension("_vmedaq",
                              ["pyvmedaq.c","buffer.c"],
                              libraries=libs,
                              include_dirs=cflags
                              ),
#                    Extension("vatagp",["vatagp.c"])
                    ]
    )

#----------------------------------------------------------------------------
