#!/usr/bin/env python

class Tracer(object):
    def __init__(self,npoints, average=0):
        self.data = [ ]
        self.average = average

        self.size = npoints
        self.cntr = 1
        self.val  = 0.
        self.callback=None
        self.observers = {}

    def fill(self,val):
        if self.average>1:
            self.val = ( val + self.cntr * self.val)/(self.cntr+1.)
            self.cntr += 1
            if self.cntr % self.average == 0:
                self.add_point(self.val)
                self.cntr=1
                self.val=0.
                    
        else:
            self.add_point(val)

    def add_point(self,val):
        self.data.append(val)
        if len(self.data)>self.size:
            self.data.pop(0)

        for x,cb in self.observers.items():
            cb(self.data)

        if self.callback:
            self.callback(self.data)

    def register(self,fcn,args=None):
        def __callback(data):
            return fcn(data,args)

        if callable(fcn):
            self.observers[fcn] = __callback


#-------------------------------------------------------------------------
