#!/usr/bin/env python

import sys
import timeit
sys.path.insert(0,'/home/lacasta/test/py-vmedaq/build/lib.linux-i686-2.3')


import vmedaq

class TestBase(vmedaq.VATAGP):
    def __init__(self):
        super(TestBase,self).__init__()

    def onNewData(self,module,evtcnt,channels):
        if (self.cnt % 10)==0:
            print ('\r%8d %8d'%(self.cnt,evtcnt)),
            sys.stdout.flush()

    def MapRecord(self,data):
        print '*** Map Record'
        super(TestBase,self).MapRecord(data)
        id = data[1];
        module = self.idlist[id]
        for x in module.map:
            print x

    def ScanRecord(self,data):
        print '*** Scan Record found'
        super(TestBase,self).ScanRecord(data)
        for x in self.vars:
            print x


class TestCompiled(TestBase):
    def __init__(self):
        super(TestCompiled,self).__init__()
        

    def PedestalRecord(self,data):
        print '*** Pedestal Record'
        md = self.idlist[256]
        print md
        id = vmedaq.decode_pedestal(data,self.idlist)
        md = self.idlist[id];
        print md
        if len(md.pedestals)!=md.ntot:
            print 'PedestalRecord: insonsistent array size'


    def DataRecord(self,data):
        self.cnt += 1
        self.ndata += 1
        vmedaq.decode_vatagp(self,data)


def test_compiled():
    try:
        file = sys.argv[1]
    except IndexError:
        file = 'Ba-spectrum.data'
        
    S = TestCompiled()
    V = vmedaq.VMEdaq()
    V.open(file)
    V.register( S )

    try:
        V.loop()
    except vmedaq.VMEdaqError,e:
        print "Algo ha salido mal:",e
        
    except KeyboardInterrupt:
        print 'Arrrrggggg!!!!'

    V.close()
    print 'End of Loop'

def test_base():
    S = TestBase()
    V = vmedaq.VMEdaq()
    V.open("Ba-spectrum.data")
    V.register( S )

    try:
        V.loop()
    except vmedaq.VMEdaqError,e:
        print "Algo ha salido mal:",e
        
    except KeyboardInterrupt:
        print 'Arrrrggggg!!!!'

    V.close()
    print 'End of Loop'



if __name__=='__main__':
##     print 'The compiled version:'
##     t1 = timeit.Timer("test_compiled()", "from __main__ import test_compiled")
##     rc = t1.timeit(number=1)
##     print 'rc=',rc
    
##     print '\n\nThe normal version'
##     t2 = timeit.Timer("test_base()", "from __main__ import test_base")
##     rc=t2.timeit(number=1)
##     print 'rc=',rc
    test_compiled()
        
