#!/usr/bin/env python

import sys
sys.path.insert(0,'/home/lacasta/test/py-vmedaq/build/lib.linux-i686-2.3')


import vmedaq


class Scan(vmedaq.VATAGP):
    def __init__(self):
        
        super(Scan,self).__init__()

        self.nevts = 0
        self.vars = []

    
    def __str__(self):
        return "MyObserver"

    def onNewFile(self, file_name):
        str = (len(file_name)+4)*'+'
        print '%s\n+ %s\n%s' % (str,file_name,str)


    def onNewPoint(self,nevts,data):
        self.nevts = nevts
        self.vars  = data
##         print "-----------------------------"
##         print "New point",self.cnt,"N. var",len(data),"N. evts",nevts
##         for type,val in data:
##             print '\t',vmedaq.var_names[type],'val',val

    def onEndPoint(self):
        val = self.cnt/float(self.nevts)
        self.graph.SetPoint(self.npoint,self.vars[0][1],val)

        print self.npoint,self.vars[0][1],val
            


class Spectrum(vmedaq.VATAGP):
    def __init__(self):
        super(Spectrum,self).__init__()
        
    
    def __str__(self):
        return "Spectrum"

    def onNewData(self,module,evtcnt,data):
        for T in data:
            is_signal=False
            chan,val = T[0:2]
            if len(T)==3:
                is_signal=True

            if chan<0 or chan>=module.ntot:
                continue
        
            ped = module.pedestals[chan]
            v   = val-ped

        if (self.cnt % 1000)==0:
            print ('\r%8d'%self.cnt),
            sys.stdout.flush()

    def onNewFile(self,file_name):
        str = (len(file_name)+4)*'+'
        print '%s\n+ %s\n%s' % (str,file_name,str)

def Af(*data):
    print '%x' % data[0][0]

def main():
#    S = Scan()
    S = Spectrum()
    V = vmedaq.VMEdaq()
    V.register( S )
#    V.register(Af)

#    V.open(["scan-real.data"]);
#    V.open("thr-scan.data")
    V.open("Ba-spectrum.data")
#    V.open("/tmp/run000001_000.data")
    
    while 1:
        try:
            bt = V.read()
            if bt==None:
                break
        except vmedaq.VMEdaqError,e:
            print "Algo ha salido mal:",e
            break



    
    print "End of file"
    V.close()


if __name__=='__main__':
    try:
        main()
    except KeyboardInterrupt:
        print 'Arrrrrggggg!!!!!'
        
    print 'Adios...'
#-------------------------------------------------------------------------
