#!/usr/bin/env python
import sys
import vmedaq

class Scan(vmedaq.VATAGP):
    def __init__(self):
        super(Scan,self).__init__()

    def onScan(self):
        print '====================================='
        print ' Scan'
        print '====================================='
        for v in self.vars:
            print '%10s npts %5d first %6.2f last %6.2f' % (
                vmedaq.var_names[v.type],v.npts,v.first,v.last)

    def onNewPoint(self,nevts,data):
        print "-----------------------------"
        print "New point",self.ndata,"N. var",len(data),"N. evts",nevts
        for type,val in data:
            if type == vmedaq.pulse:
                val = val/100.
                
            print '\t%10s val: %6.2f' %(vmedaq.var_names[type],val)
        

def main():
    file_list = [ file for file in sys.argv[1:] ]
    if len(file_list)==0:
        print 'I need an input file'
        sys.exit(0)

        
    S = Scan()
    V = vmedaq.VMEdaq()
    V.register( S )
    V.open(file_list)
    
    try:
        V.loop()
    except vmedaq.VMEdaqError,e:
        print "Algo ha salido mal:",e

    print '\nEnd of Loop'
    

if __name__=='__main__':
    print 'On y va !!!!'
    try:
        main()
    except KeyboardInterrupt:
        print 'Arrrrrggggg!!!!!'
        
    print 'Adios...'

#-------------------------------------------------------------------------


