#!/usr/bin/env python

import sys
import getopt
import struct

import vmedaq

class DumpData(object):
    def __init__(self,fname):
        self.file = open(fname,'w')
        self.szL = struct.calcsize('L')
        self.data = ()
        self.evtnum = 0
    def read(self):
        s = self.file.read(2*self.szL)
        L,self.evtnum = struct.unpack('LL',s)

        fmt = '%dd' % L
        szA = struct.calcsize(fmt)
        s = self.file.read(szA)
        self.data = struct.unpack(fmt,s)

class Spectrum(vmedaq.VATAGPtest):
    def __init__(self, dtype, use_up=0):
        super(Spectrum,self).__init__(dtype, use_up)
        
    
    def __str__(self):
        return "Spectrum"

        
    def onNewData(self,module,evtcnt,data):
        print '**** Evt:', evtcnt
        for chan,val,adj in data:
            print chan,val,adj


    def onNewFile(self,file_name):
        str = (len(file_name)+4)*'+'
        print '%s\n+ %s\n%s' % (str,file_name,str)


def main():
    file_list = [ file for file in sys.argv[1:] ]
    print file_list

    V = vmedaq.VMEdaq()
    V.register( Spectrum(0x10000) )
    V.open(file_list)
    
    try:
        V.loop()
    except vmedaq.VMEdaqError,e:
        print "Algo ha salido mal:",e
    except KeyboardInterrupt:
        print 'Arrrrgggg !!!!!' 


    print 'End of Loop'
    print "End of file"
    V.close()


if __name__=='__main__':
    try:
        main()
    except KeyboardInterrupt:
        print 'Arrrrrggggg!!!!!'
        
    print 'Adios...'
#-------------------------------------------------------------------------
