#!/usr/bin/env python

import sys
import getopt
sys.path.insert(0,'/home/lacasta/test/py-vmedaq/build/lib.linux-i686-2.3')

import itertools
import ROOT
import vmedaq
from Tracer import Tracer

saves = {}
def save_root_object(O):
    saves[O.GetName()]=O



class Spectrum(vmedaq.VATAGP):
    def __init__(self):
        super(Spectrum,self).__init__(1)
        
        self.cnvs  = ROOT.TCanvas("cnvs")
        save_root_object(self.cnvs)

        self.hst   = ROOT.TH1F("hdiff","diff. down-up",202,-100.5,100.5)
        save_root_object(self.hst)
    
    def __str__(self):
        return "Spectrum"

        
    def onNewData(self,module,evtcnt,data):
        i=0
        old=0.
        for chan,val,adj in itertools.ifilter(lambda x: x[2]==0,data):
            if i % 2 == 1:
                self.hst.Fill(old-val)
            
            i += 1
            old = val

        
        if (self.ndata%10000)==0:
            self.hst.Draw()
            self.cnvs.Modified(1)
            self.cnvs.Update()

        if (self.ndata % 1000)==0:
            print ('\r%8d'%self.ndata),
            sys.stdout.flush()

    def onNewFile(self,file_name):
        str = (len(file_name)+4)*'+'
        print '%s\n+ %s\n%s' % (str,file_name,str)

def Af(*data):
    print '%x' % data[0][0]

def main(file_list):
    print file_list

    ROOT.gROOT.SetStyle("Plain")
    ROOT.gStyle.SetOptStat(0)

    V = vmedaq.VMEdaq()
    V.register( Spectrum() )
    V.open(file_list)
    
    try:
        V.loop()
    except vmedaq.VMEdaqError,e:
        print "Algo ha salido mal:",e
    except KeyboardInterrupt:
        print 'Arrrrgggg !!!!!' 


    print 'End of Loop'
    ROOT.gApplication.Run(1)
    print "End of file"
    V.close()


if __name__=='__main__':
    try:
        main([ file for file in sys.argv[1:] ])
    except KeyboardInterrupt:
        print 'Arrrrrggggg!!!!!'
        
    print 'Adios...'
#-------------------------------------------------------------------------
