#!/usr/bin/env python
"""
    An client for the xmlrpc server
"""

import sys
import time
import socket
import xmlrpclib
from DAQXMLrpcClient import xmlModule, xmlRunManager


# Create an object to represent our server.
server_url = 'http://%s:%d' % (socket.gethostname(),8080)
print 'Connecting to',server_url
server = xmlrpclib.Server(server_url, verbose=False)

print "List of xmlRunManager Objects"
runm_list = server.get_runmanager_list()
print runm_list

#for runm in runm_list:
#    obj = xmlRunManager(server, runm)
#    print "xmlRunManager",runm
#    print  obj.get_status()

print "List of Modules"
module_list = server.get_module_list()
modules = {}
print module_list
for name in module_list:
    obj = xmlModule(server, name)
    modules[name] = obj
    print 'xmlModule: ', name
    print obj.get_status()

print "xmlModule parameters:"
for id in module_list:
    print "xmlModule:", id 
    md = modules[id]
    print "---", md.get_par_names()
    for par in md.get_par_names():
        print "...param ",par
        sys.stdout.flush()
        val = md.get_par(par)
        print " value", val
        
print 'Getting monitor data'
for id in module_list:
    print "xmlModule:", id 
    md = modules[id]
    data = md.get_mon_data()
    print "size of monitor data is", len(data)
    