/* -*- mode: c++ -*- */
#ifndef __ConfigException_h__
#define __ConfigException_h__

#include <exception>
#include <string>
/**
 \brief class ConfigException
 \ingroup CONFIG

 This is the exception thrown when there is some problem with the
 configuration
 */

class ConfigException : public std::exception
{
    protected:
        std::string _why;
    public:
        ConfigException(const std::string &msg) :
            _why(msg)
        {
        }
        ConfigException(const ConfigException &e)
        {
            _why = e._why;
        }
        virtual ~ConfigException() throw()
        {
        }
        const char* what() const throw();
};

#endif
