#ifndef HSTCOLOR_H_
#define HSTCOLOR_H_
#include <string>
/**
 * This class represents a color for the Monitor Histograms
 */
class HstColor
{
    private:
        std::string _bg, _fg, _axis;
        void cpy(const HstColor &c);
    public:
        HstColor();
        ~HstColor();
        HstColor(const std::string &bg, const std::string &fg, const std::string &ax)
            : _bg(bg), _fg(fg), _axis(ax) {}

        HstColor(const HstColor &c) { cpy(c); }
        HstColor &operator=(const HstColor &c);

        const std::string &bg() const { return _bg; }
        void bg(const std::string &x) { _bg=x; }

        const std::string &fg() const { return _fg; }
        void fg(const std::string &x) { _fg=x; }

        const std::string &axis() const { return _axis; }
        void axis(const std::string &x) { _axis=x; }

        void set_colors(const std::string &bg, const std::string &fg, const std::string &ax);
};

#endif /*HSTCOLOR_H_*/
