#ifndef __PluginException_h__
#define __PluginException_h__

#include <string>
#include <exception>

/**
 * \brief class PluginException
 * \ingroup CONFIG
 * 
 * This is the exception thrown by PluginParser with a
 * symbol is not found in the library
 */
class PluginException : public std::exception
{
    protected:
        std::string _why;
    public:
        PluginException(const std::string &msg) :
            _why(msg)
            {}
        PluginException(const PluginException &e)
        {
            _why = e._why;
        }
        virtual ~PluginException() throw() {}
        const char *what() const throw();
};

#endif /*__PluginException_h__*/
