#include <sstream>
#include <string>
#include <cstdlib>
#include <unistd.h>
#include "SchemaPath.h"

SchemaPath::SchemaPath()
{
    const char *home = getenv("HOME");
    const char *env = getenv("SCHEMA_PATHS");
    char buf[256];
    std::string data_dir = std::string(DATA_DIR) + "/config";
    paths.push_back(".");
    paths.push_back(data_dir);
    if (home)
        paths.push_back( std::string(home) + "/.vmedaq" );

    if (env)
    {
        std::istringstream path(env);
        while (path)
        {
            path.getline(buf, sizeof(buf), ':');
            paths.push_back(buf);
        }
    }
}

void
SchemaPath::add_path(const std::string &s)
{
    paths.push_back(s);
}

std::string SchemaPath::find_schema(std::string schema, std::string directory)
{
    std::string sch;

    // Add directory at the front of the path list
    if (!directory.empty())
        paths.insert(paths.begin(), directory);

    // loop on the folders
    std::vector<std::string>::iterator ip;
    for (ip = paths.begin();ip != paths.end();++ip)
    {
        sch = *ip + "/" + schema;
        if ( !access(sch.c_str(), F_OK) )
            break;
    }

    // delete directory from the top of the list
    if (!directory.empty())
        paths.erase( paths.begin() );

    return sch;
}
