#ifndef __SearchPath_h__
#define __SearchPath_h__

#include <string>
#include <vector>
#include <map>
#include <iosfwd>

class SearchPath : private std::vector<std::string>
{
    private:
        bool is_file(const std::string &);
        void cpy(const SearchPath &p);
        std::map<std::string, int> _paths;
    public:
        SearchPath(const std::string &p="");
        SearchPath(const SearchPath &P);
        SearchPath &operator=(const SearchPath &P);
        virtual ~SearchPath();

        using std::vector<std::string>::iterator;
        using std::vector<std::string>::const_iterator;
        using std::vector<std::string>::begin;
        using std::vector<std::string>::end;
        using std::vector<std::string>::empty;
        using std::vector<std::string>::size;
        
        bool has_path(const std::string &) const;
        void add_path(const std::string &p);
        void add_path(const SearchPath &p);
        void prepend_path(const std::string &p);
        void prepend_path(const SearchPath &p);
        void purge();
        std::string find_file(const std::string &fnam);
};
std::ostream &operator<<(std::ostream &os,const SearchPath &P);
#endif /*__SearchPath_h__*/
