#ifndef __DAQcontroller_h__
#define __DAQcontroller_h__

#include <string>
#include <daq/Rmanager.h>
class MyServer;
class MainWindow;
class DAQcontroller
{
    private:
        /// Unique instance
        static DAQcontroller theInstance;
        std::string ior_loc;
        MainWindow *wnd;
        
        MyServer *corba_server;
    protected:
        /// Hide the constructors
        DAQcontroller();

        /// Copy constructor. Also hidden
        DAQcontroller(const DAQcontroller &);

        /// Assignment operator (hidden)
        void operator=(const DAQcontroller &)
        {}

    public:
        ~DAQcontroller();
        
        /// Returns a pointer to the manager
        static DAQcontroller *instance()
        {
            return &theInstance;
        }

        void setup_daq(int argc, char **argv);
        void reset_daq();
        void stop_daq();
        Rmanager *get_run_manager();
        void set_main_window(MainWindow *w);
};

#endif /*DAQCONTROLLER_H_*/
