/* -*- mode: c++ -*- */
#ifndef __vmedaq_dummy_module_h__
#define __vmedaq_dummy_module_h__

#include <DAQ++/Module.h>

/**
 * This is a dummy module that we will use to interact remotely with
 * vmedaq.
 */
class MainWindow;

class DummyModule : public DAQpp::Module
{
private:
    MainWindow *mw;

class Spy : public Observer
    {
    private:
        DummyModule *md;
    public:
        Spy(DummyModule *p = 0) : md(p)
        {}
        void update(Observable *o, Argument *arg);

        void change_trigger_type( const std::string &type);
        void change_interrupt( const std::string &type);
        void do_pedestal(int nevt);
    }
    the_spy;
public:
    DummyModule(DAQpp::DAQid const id, MainWindow *ptr = 0);

    ~DummyModule()
    {}
    void sync();

    int PrepareForRun()
    {
        return 0;
    }
    int Start(int mode = 0)
    {
        return 0;
    };
    int Stop(int mode = 0)
    {
        return 0;
    };
    int Pause()
    {
        return 0;
    };
    int Continue()
    {
        return 0;
    };
    int Reset()
    {
        return 0;
    };
    int GetReady()
    {
        return 0;
    };
    int Trigger()
    {
        return 0;
    };
    void flush()
    {
        return;
    };
    bool hasData()
    {
        return false;
    }
    char *getData(int &size)
    {
        size = 0;
        return 0;
    }
    void add_par(const char *pnam, DAQpp::Parameter *par, const DAQpp::DAQid *id = 0)
    {
        DAQpp::DAQObject::add_par(pnam, par);
        par->addObserver( the_spy );
    }
    void main_window( MainWindow *ptr )
    {
        mw = ptr;
        sync();
    }
    MainWindow *main_window() const
    {
        return mw;
    }


};

#endif
