#include <iostream>
#include <DAQ++/DAQmanager.h>
#include "../data/Analysis.h"
#include "../data/DataFormat.h"
#include "MyMonitor.h"
#include "GenModule.h"

//---------------------------------------------------------------------
// Monitorig
//---------------------------------------------------------------------

bool MyMonitor::user_run(DAQpp::Event*evt)
{
    unsigned int *data;

    // Get the Module ID from the data
    data = (unsigned int *)evt->data();
    if ( (data[0] & 0xffff0000L) != 0xcafe0000)
    {
        std::cout << "Wrong Event " << std::hex << data[0] << std::dec << std::endl;
        return true;
    }

    DAQpp::DAQid id = (unsigned long)((data[2] & 0xfff00000) >> 20);
    DAQpp::Module *mm = DAQpp::DAQmanager::theDAQmanager()->find_module(id);
    if ( mm )
    {
        GenModule *module = dynamic_cast<GenModule *>(mm);
        if ( module )
        {
            module->get_analysis()->Fill(data);
        }
    }
    return true;
}
