/* -*- mode: c++ -*- */
#ifndef __vmedaq_gui_pedestals__
#define __vmedaq_gui_pedestals__

#include <gtk/gtk.h>
#include <GladeApp.h>
#include <daq/GenModule.h>

class ModuleParser;

class PedestalGui : public GladeApp
{
private:
    bool for_read;
    std::string msg;
    static void onCancel(GtkWidget *, PedestalGui *);
    static void onOK(GtkWidget *, PedestalGui *);
    static void onOpen(GtkWidget *, PedestalGui *);
    static void onHelp(GtkWidget *, PedestalGui *);
    static void onReset(GtkWidget *, PedestalGui *);
    static void onSelectModule(GtkWidget *, PedestalGui *);

    GenModule *find_module(ModuleParser **mp=0);
    bool       change_module();
public:
    PedestalGui(bool reading, const std::string &s)
            : for_read(reading), msg(s)
    {}

    // GladeApp methods
    void user_init();
    void auto_connect();
};

#endif
