#ifndef __DAQ_RunMenu_h__
#define __DAQ_RunMenu_h__

#include <map>
#include <queue>
#include <DAQ++/DAQid.h>
#include <DAQ++/RunState.h>
#include <gtk/gtk.h>
#include <gui/runmenu.h>

class RunMenu
{
public:
    typedef std::map<std::string, RunMenu *> RunMenuList;
private:
    Runmenu *runmenu;
    GtkButton *btn;
    DAQpp::DAQid  _id;
    static void btn_clicked(GtkWidget *, gpointer);
    static void daq_command(GtkWidget *w, unsigned int cmd, RunMenu *);
    static RunMenuList vlist;
public:
    RunMenu(const DAQpp::DAQid &, GtkWidget *btn, DAQpp::RunState::StatusType s = DAQpp::RunState::NotDefined);

    ~RunMenu();

    void update(DAQpp::RunState::StatusType s);
    void update_state(DAQpp::RunState::StatusType s);
    static DAQpp::RunState::StatusType translate( unsigned int );

    const DAQpp::DAQid &get_id() const
    {
        return _id;
    }
    static void delete_all();
    static void delete_menu( const DAQpp::DAQid &id );
    static RunMenu *new_menu( const DAQpp::DAQid &id,
                              GtkWidget *o,
                              DAQpp::RunState::StatusType s = DAQpp::RunState::NotReady);
    static RunMenu *find(const std::string &);

    void send_command( unsigned int cmd );
};

#endif
