#ifndef __SpinSlider_h__
#define __SpinSlider_h__
#ifdef __cplusplus
extern "C"
{
#endif    /* __cplusplus */
#include <gdk/gdk.h>
#include <gtk/gtkfixed.h>
#include <gtk/gtkadjustment.h>
#include <gtk/gtkhscale.h>
#include <gtk/gtkspinbutton.h>

#define TYPE_SPINSLIDER            (spinslider_get_type())
#define SPINSLIDER(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj),TYPE_SPINSLIDER, SpinSlider))
#define SPINSLIDER_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass),TYPE_SPINSLIDER, SpinSliderClass))
#define IS_SPINSLIDER(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj),TYPE_SPINSLIDER))
#define IS_SPINSLIDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SPINSLIDER))
#define SPINSLIDER_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SPINSLIDER, SpinSliderClass))

    typedef struct _SpinSlider SpinSlider;
    typedef struct _SpinSliderClass SpinSliderClass;

    struct _SpinSlider
    {
        GtkFixed fixed ;
    GtkAdjustment *adj;
    GtkHScale *mScale;
    GtkSpinButton *mSpin;
    float ratio;
};

struct _SpinSliderClass
{
    GtkFixedClass parent_class;
    void (*spinslider) (SpinSlider * spsl);
    };

    GType     spinslider_get_type (void) G_GNUC_CONST;
    GtkWidget *gtk_spinslider_new (gfloat v, gfloat lw, gfloat up, gfloat stp, gfloat pg, gfloat pg_siz);
    gfloat     gtk_spinslider_get_value (SpinSlider *);
    void       gtk_spinslider_set_value (SpinSlider *, gfloat);
    void       gtk_spinslider_reset (SpinSlider *, gfloat lw, gfloat up, gfloat stp, gfloat pg);
    void       gtk_spinslider_set_digits (SpinSlider *, int);
    void       gtk_spinslider_set_ratio (SpinSlider *, float);
#ifdef __cplusplus
}
#endif    /* __cplusplus */
#endif
