/* -*- mode: c++ -*- */
#ifndef __module_gui_h__
#define __module_gui_h__

#include <string>
#include <gui/WidgetUpdate.h>
#include <gui/GladeApp.h>
#include <gui/MonitorWindow.h>
#include <daq/GenModule.h>

class Analysis;
/**
   \brief class module_gui
   \ingroup GUI

   This class handles the small module monitor in the main
   window.
*/
class module_gui : public GladeApp, public WidgetUpdate, public WidgetHolder
{
private:
    GenModule      *module;  // pointer to the module

    MonitorWindow *_monitor;
    WidgetHolder::updateList monitorUpdates;
    bool    ignoreMonBtn;

    GtkWidget *_control;
    GtkWidget *_config;
    GtkWidget *_dac;


    void kill_monitor();

    static void on_btnConfig(GtkWidget * w, module_gui * ptr);
    static void on_swMonitor(GtkWidget * w, module_gui * ptr);
    static void on_swLocal(GtkWidget * w, module_gui * ptr);

    static void onConfig_destroy(GtkWidget * w, module_gui * ptr);
    static void onMonitor_destroy(GtkWidget * w, module_gui * ptr);
    static void onDACs_destroy(GtkWidget * w, module_gui * ptr);

public:
    module_gui(const std::string &id);
    ~module_gui();
    GtkWidget *monitor();
    std::string id() const;
    int update(Update & ptr);

    // The GladeApp functions
    void auto_connect();
    void user_init();
};

#endif
