#include <vector>

class BGOmap{
public:
  struct Point{
    double x;
    double y;
  };
  
  struct Triangle{
    Point A;
    Point B;
    Point C;
  };
  
  struct Quadrangle{
    Point A;
    Point B;
    Point C;
    Point D;
  };
  
  struct pointMin{
    Point p;
    pointMin();
    double v[9];
    int idx[9];
    int imin;
  };

public:
  BGOmap(const char *file=0):map_set(0){parseBoundaries(file);}
  ~BGOmap(){;}
  void parseBoundaries (const char *file);
  int getNearestPoint(const Point& p);
  static bool in_quadrant(const Point& p, const Triangle& t);
  void getFinePosition(const Point& p);
  int getCrystalID(const Point& p);
  int getMeshLowLeftCornerID(const Point& p);
  static void GetUV(int i, int &u, int & v);
  static int GetI(int u, int v);
  bool is_set(){ return map_set;}
private:
  bool check_that_central_is_min(pointMin& pm, int icentral, int& imin);
  void shift_to_min(pointMin& pm, int icentral, int imin);

private:
  std::vector<Point> bMap;
  static const int nX=8;
  static const int nY=4;
  static const double xMin=0;
  static const double xMax=128;
  static const double yMin=0;
  static const double yMax=128;
  bool map_set;
};

double operator*(const BGOmap::Point& a, const BGOmap::Point& b);
BGOmap::Point operator-(const BGOmap::Point& a, const BGOmap::Point& b);
BGOmap::Point operator+(const BGOmap::Point& a, const BGOmap::Point& b);

