#include <config/Config.h>
#include "CSprint.h"
#include "CSprint_analysis.h"

CSprint_analysis::CSprint_analysis(int n_chip, int n_chan) :
    Analysis(n_chip, n_chan)
{
}

CSprint_analysis::~CSprint_analysis()
{
}

void CSprint_analysis::decode(unsigned int *data)
{
    double *out = Event();
    int i;
    ADCRecord *adc;
    ConfigParser  *cfg  = ConfigParser::theConfig();
    GeneralConfig *gnrl = dynamic_cast<GeneralConfig *>(cfg->get_handler("general"));

    DoCommonMode(false);
    // Clear output array
    for (i = 0;i < Ntot();i++)
        out[i] = 0.;


    std::vector<int> chan_list;
    chan_list.reserve(NCHAN);

    adc = reinterpret_cast<ADCRecord *>(data + 3);
    adc->version = 0;
    for (i = 0;i < NCHAN;i++)
    {
        out[i] = adc->adc[i];
        chan_list.push_back(i);
    }
    if ( gnrl->get_ped_method() == GeneralConfig::normal )
    {
        update_pedestals(chan_list, true);
    }
    else
    {
        update_pedestals_fast(chan_list, true);
    }
    
}
