#ifndef __SIS3300_config_h__
#define __SIS3300_config_h__
#include <string>
#include <DAQ++/DAQid.h>
#include <gui/WidgetUpdate.h>
#include <gui/GladeApp.h>
#include <gui/MonitorWindow.h>
#include "SIS3300module.h"




//////////////////////////////////////////////////////////////////////////
// class SIS3300moduleGuiConf
//
//   Created: Tue Aug 01 10:14:35 2006        Author: Eric Cochran
//   Purpose:
//
//   Modified from:
// class VATAmoduleGuiConfig
//
//   Created: Mon May 27 11:40:50 2002        Author: Carlos Lacasta
//   Purpose:
//
//////////////////////////////////////////////////////////////////////////
class SIS3300moduleGuiConf : public GladeApp
{
private:
    DAQpp::DAQid _id;
    unsigned long df;

    SIS3300module *module;

    MonitorWindow *_monitor;

    static void onOK(GtkWidget *w, SIS3300moduleGuiConf *d);
    static void onApply(GtkWidget *w, SIS3300moduleGuiConf *d);
    static void onCancel(GtkWidget *w, SIS3300moduleGuiConf *d);

    static void on_checkALL(GtkWidget *w, SIS3300moduleGuiConf *d);
    static void on_checkEditThresholds(GtkWidget *w, SIS3300moduleGuiConf *d);

public:
    SIS3300moduleGuiConf(const DAQpp::DAQid &id);
    ~SIS3300moduleGuiConf();
    void update();
    void set_values();
    void toggleThresholds();
    void toggleEditThresholds();

    // GladeApp methods
    void user_init();
    void auto_connect();
};

#endif
