#ifndef __SecondDetector_config_h__
#define __SecondDetector_config_h__
#include <string>
#include <DAQ++/DAQid.h>
#include <gui/WidgetUpdate.h>
#include <gui/GladeApp.h>
#include <gui/MonitorWindow.h>
#include "SecondDetector.h"



//////////////////////////////////////////////////////////////////////////
// class SecondDetectorGuiConf
//
//   Created: Tue Aug 01 10:14:35 2006        Author: Eric Cochran
//   Purpose:
//
//   Modified from:
// class VATAmoduleGuiConfig
//
//   Created: Mon May 27 11:40:50 2002        Author: Carlos Lacasta
//   Purpose:
//
//////////////////////////////////////////////////////////////////////////
class SecondDetectorGuiConf : public GladeApp
{
private:
    DAQpp::DAQid _id;
    unsigned long df;

    SecondDetector *module;

    MonitorWindow *_monitor;

    static void onOK(GtkWidget *w, SecondDetectorGuiConf *d);
    static void onApply(GtkWidget *w, SecondDetectorGuiConf *d);
    static void onCancel(GtkWidget *w, SecondDetectorGuiConf *d);
    static void on_ConfigAmp(GtkWidget *w, SecondDetectorGuiConf *d);

    static void on_checkEditThresholds(GtkWidget *w, SecondDetectorGuiConf *d);
    static void on_checkAllThresholds(GtkWidget *w, SecondDetectorGuiConf *d);
    static void on_checkEditAmplifiers(GtkWidget *w, SecondDetectorGuiConf *d);
    static void on_checkAllAmplifiers(GtkWidget *w, SecondDetectorGuiConf *d);
    static void on_spinAmplifier(GtkWidget *w, SecondDetectorGuiConf *d);
    static void on_checkAmpEditDelay(GtkWidget *w, SecondDetectorGuiConf *d);
    static void on_checkAmpEditGains(GtkWidget *w, SecondDetectorGuiConf *d);
    static void on_checkAmpAllGains(GtkWidget *w, SecondDetectorGuiConf *d);

public:
    SecondDetectorGuiConf(const DAQpp::DAQid &id);
    ~SecondDetectorGuiConf();
    void ConfigAmp();
    void update();
    void set_values();
    void setThresholds();
    void setSlaveValues();
    void toggleEditThresholds();
    void toggleThresholds();
    void toggleEditAmplifiers();
    void toggleAllAmplifiers();
    void toggleAmpEditDelay();
    void toggleAmpEditGains();
    void toggleAmpGains();
    void getAmpValues();
    void setAmpValues();

    // GladeApp methods
    void user_init();
    void auto_connect();
};

#endif
