#ifndef __FTDI_USB__
#define __FTDI_USB__

#include "ftdi.h"
#include <map>
#include <usb.h>

using namespace std;

class ftdiPort;

class ftdiUSB
{

public:
    ftdiUSB(unsigned int serial = 0);
    ~ftdiUSB();
    void open(unsigned int serial = 0);
    void close();
    unsigned int get_serial();
    //const{return address;}
    ftdiPort *getPort(enum ftdi_interface interface);
    void set_serial(unsigned int _serial, int check = 1);


public:
    static unsigned int decode_serial(const unsigned char *eeprom);
    static void code_serial(unsigned int serial, ftdi_eeprom *eeprom);

    //static unsigned int get_serial(ftdi_context *ftdi);

private:
    struct usb_device *find_device(unsigned int serial);
    static void set_usbList();
    static void clear_usbList();

private:
    map<enum ftdi_interface, ftdiPort *> ftdiList;
    //map<unsigned int,struct usb_device *> usbList;
    static struct usb_device ** usbList;
    static unsigned int *usbSerialNo;
    static int nDevices;
    //ftdi_context ftdic[2];
    //static enum ftdi_interface interfaceID[2];
    //unsigned int serial;
};

class ftdiUSB_Error
{
    ;
};

class ftdiPort
{

public:
    ftdiPort(ftdi_interface interface, struct usb_device *usb);
    ~ftdiPort();

public:
    int write(unsigned char data);
    int read(unsigned char & data)
    {
        return 0;
    }
    unsigned int get_serial();
    void write_eeprom(unsigned char output[], int check = 1);

private:
    void open(ftdi_interface interface, struct usb_device *usbdev);
    //void open();
    void close();

private:
    ftdi_context *ftdi;
};

class ftdiPort_Error
{
    ;
};

#endif
