#include <iostream>
#include <iomanip>
#include "TDCCaen488_analysis.h"
#include "tdc488.h"

void TDCCaen488_analysis::decode(unsigned int *data)
{
    double *out = Event();
    double *chan = Chan();
    unsigned short dt;
    dataWord *val = (dataWord *)&dt;
    int i, sz = data[2] & 0xffff;

    // Clear output array
    for (i=0; i<Ntot(); i++)
        chan[i]=out[i]=0.;

    for (i=0; i<sz; i++)
    {
        dt = (data[3+i] & 0xffff);
        if ( !val->header)
        {
            out[val->channel] = val->val;
            chan[val->channel] = val->val;
            add_hit(val->channel);
        }
    }
}

void TDCCaen488_analysis::Analyze()
{
    if (hits.empty() )
        return;

    int chan, bin;
    for (chan=hits.top(); 1;)
    {
        bin = get_bin( *Chan(chan) );

        hits.pop();

        HitMap()[chan]++;
        Signal(-1)[bin]++;
        Signal(chan)[bin]++;

        if (hits.empty() )
            break;
        chan = hits.top();
    }
}

