/* -*- mode: c++ -*- */
#ifndef __VATAmodule_config_h__
#define __VATAmodule_config_h__
#include <string>
#include <DAQ++/DAQid.h>
#include <gui/WidgetUpdate.h>
#include <gui/GladeApp.h>

class TAmanager;


//////////////////////////////////////////////////////////////////////////
// class VATAmoduleGuiConfig
//
//   Created: Mon May 27 11:40:50 2002        Author: Carlos Lacasta
//   Purpose:
//
//////////////////////////////////////////////////////////////////////////
class VATAmoduleGuiConfig : public GladeApp
{
    private:
        DAQpp::DAQid _id;
        unsigned long df;
        TAmanager *tav;

        static void onOK(GtkWidget *w, VATAmoduleGuiConfig *d);
        static void onApply(GtkWidget *w, VATAmoduleGuiConfig *d);
        static void onCancel(GtkWidget *w, VATAmoduleGuiConfig *d);
        static void onNewChip(GtkWidget *w, VATAmoduleGuiConfig *d );
        static void onPolChanged(GtkWidget *w, VATAmoduleGuiConfig *d);
        static void onGainToggled(GtkWidget *, VATAmoduleGuiConfig *);
        static void onGainChanged(GtkWidget *, VATAmoduleGuiConfig *);
        static void onTestToggled(GtkWidget *, VATAmoduleGuiConfig *);
        static void onBtnToggled(GtkWidget *, VATAmoduleGuiConfig *);
        static void onProbeToggled(GtkWidget *, VATAmoduleGuiConfig *);
        static void onNsideToggled(GtkWidget *, VATAmoduleGuiConfig *);
        static void onCCToggled(GtkWidget *, VATAmoduleGuiConfig *);
        static void onChipIDChanged(GtkWidget *, VATAmoduleGuiConfig *);
        static void onTxtChanged(GtkWidget *, VATAmoduleGuiConfig *);
        static int  onUpdate(VATAmoduleGuiConfig *);
        static void onMaskAll(GtkWidget *, VATAmoduleGuiConfig *);
        static void onClearMask(GtkWidget *, VATAmoduleGuiConfig *);
        static void onTestAll(GtkWidget *, VATAmoduleGuiConfig *);
        static void onClearTest(GtkWidget *, VATAmoduleGuiConfig *);
        static void onNadj(GtkWidget *, VATAmoduleGuiConfig *);
        static void onDelay(GtkWidget *, VATAmoduleGuiConfig *);
        static void onDebug(GtkWidget *, VATAmoduleGuiConfig *);
        static void on_internal_step(GtkWidget *, VATAmoduleGuiConfig *);
        static void on_internal_cap(GtkWidget *, VATAmoduleGuiConfig *);
        static void on_test_channel(GtkWidget *, VATAmoduleGuiConfig *);
        static void on_slew(GtkWidget *, VATAmoduleGuiConfig *);
        static void on_dlt(GtkWidget *, VATAmoduleGuiConfig *);
        static void on_trim_dac_range(GtkWidget *, VATAmoduleGuiConfig *);
        static void on_chip_type(GtkWidget *, VATAmoduleGuiConfig *);
        static void on_change_page(GtkNotebook *, GtkNotebookPage *, gint, VATAmoduleGuiConfig *);
        
        void draw_table(GtkTable *tbl, int indx);

        
    public:
        VATAmoduleGuiConfig(const DAQpp::DAQid &id, TAmanager *tt, const std::string &g_file);
        ~VATAmoduleGuiConfig();
        void update();
        void set_values();
        int WhichChip();
        TAchip *current_chip();
        
        
        // GladeApp methods
        void user_init();
        void auto_connect();
        void process_text(const std::string &s, GtkWidget *w);
};



#endif
