#ifndef VATAMODULE_ANALYSIS_H_
#define VATAMODULE_ANALYSIS_H_

#include <vector>
#include <data/Analysis.h>
#include "TAmanager.h"

class VATAmodule_analysis : public Analysis
{
    private:
        int  _romode;
        void decode_serial(unsigned int*, std::vector<int> &list_of_channels);
        void decode_sparse_gp3(unsigned int*, std::vector<int> &list_of_channels);
        void decode_sparse_gp5(unsigned int*, std::vector<int> &list_of_channels);
        void decode_sparse_gp7(unsigned int*, std::vector<int> &list_of_channels);
        void (VATAmodule_analysis::*decode_sparse)(unsigned int*, std::vector<int> &list_of_channels);
        
    public:
        VATAmodule_analysis(int n_chip, int n_chan);
        virtual ~VATAmodule_analysis();
        void set_chip_type(TAmanager::ChipType chip_type);
        void Analyze();
        void decode(unsigned int *data);
	const std::stack<int>& get_hits() const {return hits;}

};

#endif /*VATAMODULE_ANALYSIS_H_*/
