/* -*- mode: c++ -*- */
#ifndef FSIO_HEADER
#define FSIO_HEADER

// fSio.h

#define F_NOTIMPLEMENTED          0x5001
#define F_DEVICENOTOPEN           0x5002
#define F_READERROR               0x5003

/*
  The below has been changed from 1 to -1 (required by poll for
  an infinite wait
*/
#define EV_RXCHAR -1

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <termios.h>
#include <iostream>
#include <stdio.h>
#include <unistd.h>

class fSio
{
public:
    fSio(const char *);
    ~fSio(void);
    int fSioReset(int, int, int);
    int fSioDone(int);
    int fSioBaud(int, unsigned int);
    int fSioPutc(int, char);
    int fSioPuts(int, char *, unsigned int);
    unsigned int fSioGetc(int);
    int fSioGets(int, char *, unsigned int);
    int fSioDTR(int, char);
    int fSioRTS(int, char);
    int fSioTxClear(int);
    int fSioRxClear(int);
    int fSioTxQue(int);
    int fSioRxQue(int);
    int fSioStatus(int, unsigned int);
    int fSioFlow(int, char);
    int fSioParms(int, int, int, int);
    int fSioCTS(int);
    int fSioDSR(int);
    int fSioRI(int);
    int fSioDebug(int);
    int fSioInfo(char);
    int fSioDCD(int);
    int fSioBrkSig(int, char);
    int fSioUnGetc(int, char);
    int fSioWinError(char *, int);
    int fSioRead(int, int);
    int fSioEvent(int, long);
    int fSioNleft(int);
private:
    int fd;
    struct termios tio;
    int error;
};

#endif
