#ifndef __VelmexModuleGuiConf_h__
#define __VelmexModuleGuiConf_h__
#include <string>
#include <DAQ++/DAQid.h>
#include <gui/WidgetUpdate.h>
#include <gui/GladeApp.h>
#include <gui/MonitorWindow.h>
#include "VelmexModule.h"




//////////////////////////////////////////////////////////////////////////
// class VelmexModuleGuiConf
//
//   Created: Tue Aug 01 10:14:35 2006        Author: Eric Cochran
//   Purpose:
//
//   Modified from:
// class MyModuleGuiConfig
//
//   Created: Mon May 27 11:40:50 2002        Author: Carlos Lacasta
//   Purpose:
//
//////////////////////////////////////////////////////////////////////////
class VelmexModuleGuiConf : public GladeApp
{
private:
    DAQpp::DAQid _id;
    unsigned long df;

    VelmexModule *module;

    MonitorWindow *_monitor;

    static void onOK( GtkWidget *w, VelmexModuleGuiConf *d );
    static void onApply( GtkWidget *w, VelmexModuleGuiConf *d );
    static void onCancel( GtkWidget *w, VelmexModuleGuiConf *d );

    static void on_checkALL( GtkWidget *w, VelmexModuleGuiConf *d );
    static void on_checkEditThresholds( GtkWidget *w, VelmexModuleGuiConf *d );

public:
    VelmexModuleGuiConf( const DAQpp::DAQid &id );
    ~VelmexModuleGuiConf();
    void update();
    void set_values();
    void toggleThresholds();
    void toggleEditThresholds();

    // GladeApp methods
    void user_init();
    void auto_connect();
};

#endif
