#include <iostream>
// #include <daq/GenModule.h>
// #include <config/ConfigParser.h>
// #include <config/ModuleParser.h>

#include "VelmexScanRM.h"
#include "motor/rotaryTable.h"
#include "motor/adacTable.h"

using namespace std;

VelmexScanRM::VelmexScanRM( DAQpp::DAQid id )
        : ScanRunManager( id ), vmTable( 0 )
{
}

static int __dummy_cnt__ = 0;
void VelmexScanRM::init_run()
{
    __dummy_cnt__ = 0;
    std::cout << __PRETTY_FUNCTION__ << ':' << __LINE__ << std::endl;
}

void VelmexScanRM::new_trigger()
{
    cout << "VelmexScanRM::new_trigger()" << endl;
    //   if ( __dummy_cnt__++ < 3 )
    //     std::cout << __PRETTY_FUNCTION__ << ':' << __LINE__ << std::endl;
    //   const ScanPoint *thisPoint=&get_current();
    //   if (thisPoint!=current){
    //     std::cout<<"Change: "<<current<<"->"<<thisPoint<<std::endl;
    //     current=thisPoint;
    //   }
    //std::cout<<(&get_current())<<std::endl;

}

void VelmexScanRM::set_new_values()
{
    std::cout << "setnewvalues" << std::endl;
    ScanPoint *currentPoint = const_cast<ScanPoint *>( &get_current() );
    std::vector<ScanVar>::const_iterator ip = currentPoint->find_type( ScanVar::angle1 );

    //std::vector<ScanVar>::iterator ip = currentPoint->find_type(ScanVar::user1);
    if ( ip != currentPoint->end() )
    {
        //we are doing a scan with a rotary table

        //create a table if non exist
        if ( !vmTable ) vmTable = dynamic_cast<VelmexMotorTable *>( new RotaryTable() );

        //rotate
        RotaryTable *rt = dynamic_cast<RotaryTable *>( vmTable );
        rt->MoveTo( ip->value() );

    }

    else
    {
        //we are doing xy scan

        //create a table if none exists
        if ( !vmTable ) vmTable = dynamic_cast<VelmexMotorTable *>( new ADACtable() );

        //move axes
        ADACtable *at = dynamic_cast<ADACtable *>( vmTable );

        //find X
        std::vector<ScanVar>::iterator ix = currentPoint->find_type( ScanVar::xposition );
        //std::vector<ScanVar>::iterator ix = currentPoint->find_type(ScanVar::user2);
        if ( ix == currentPoint->end() )
        {
            std::cout << "No x variable supplied!" << std::endl;
            throw VelmexScanRM_Error();
        }

        //find Y
        //std::vector<ScanVar>::iterator iy = currentPoint->find_type(ScanVar::user3);
        std::vector<ScanVar>::iterator iy = currentPoint->find_type( ScanVar::yposition );
        if ( iy == currentPoint->end() )
        {
            std::cout << "No y variable supplied!" << std::endl;
            throw VelmexScanRM_Error();
        }

        double pos[] = {ix->value(), iy->value()};
        at->MoveTo( pos );
    }
}

/*
 * The hooks
 */
extern "C"
{
    VelmexScanRM *create_new_manager( const std::string &type,
                                      const DAQpp::DAQid &id )
    //const std::string &name)
    {
        printf( "coo-coo\n" );
        return new VelmexScanRM( id );
    }

//     MyDummyModuleConf *create_dummy_module()
//     {
//  return new MyDummyModuleConf();
//     }
}

static void __attribute__ ( ( constructor ) ) __init__lib__()
{
    printf( "### Loading VelmexScanRM...\n" );
}

static void __attribute__ ( ( destructor ) ) __close__lib__()
{
    printf( "### Unloading VelmexScanRM...\n" );
}


