/* -*- mode: c++ -*- */
#ifndef __VelmexScanRM_h__
#define __VelmexScanRM_h__

#include <daq/ScanRunManager.h>
#include <iostream>
#include "motor/velmexMotorTable.h"

class VelmexScanRM : public ScanRunManager
{
public:
    VelmexScanRM( DAQpp::DAQid id );
    ~VelmexScanRM()
    {}

    // We just add a call to init_run when Preapring to run
    void PrepareForRun()
    {
        ScanRunManager::PrepareForRun();

        // here we call our stuff
        init_run();
    }

    // Here we play the same game with Trigger.
    // It would have been nice to also get a hook when the values
    // change, but most of the needed stuff is private. However you
    // can create a dummy module that never returns data, but will be
    // notified when values change
    void Trigger()
    {
        //std::cout<<"VelmexScanRM::Trigger("<<get_event_number()<<")"<<std::endl;
        ScanRunManager::Trigger();
        //new_trigger();
    }


    /**
     *  This is where you should add your stuff
     */

    // When preparing to run
    virtual void init_run();

    // On each event, right before checking for data
    virtual void new_trigger();
public:
    virtual void set_new_values();

protected:
    VelmexMotorTable *vmTable;
    const ScanPoint *current;
};

class VelmexScanRM_Error
{
    ;
};

#endif
