#ifndef PYANALYSIS_H_
#define PYANALYSIS_H_

#include <Python.h>
#include <data/Analysis.h>
#include <DAQ++/python/pydaqpp.h>

class pyanalysis : public Analysis, public PyDAQpp
{
    public:
        pyanalysis(int nchip, int nchan);
        virtual ~pyanalysis();
        
        void Analyze();
        bool data_valid(unsigned int *data) const;
        void decode(unsigned int *data);
        void init_run();
        void end_run();
};

typedef struct
{
    PyObject_HEAD
    /* Type-specific fields go here. */
    PyObject    *dict;
    pyanalysis  *ana;
} vmedaq_analysis;
int PyVMEdaq_Analysis_Check(PyObject *O);
PyObject *PyVMEdaq_Analysis_New(int nchip, int nchan);
#endif /*PYANALYSIS_H_*/
