#ifndef PYGENMODULE_H_
#define PYGENMODULE_H_

#include <Python.h>
#include <DAQ++/python/pydaqpp_objects.h>
#include <daq/GenModule.h>

class pygenmodule: public GenModule, public PyDAQpp
{
    public:
        pygenmodule(const DAQpp::DAQid &id, unsigned long add);
        virtual ~pygenmodule();

        unsigned long get_data_type() const;
        int   PrepareForRun();
        int   Start(int x);
        int   Stop(int x);
        int   Pause();
        int   Continue();
        int   Reset();
        int   GetReady();
        int   Trigger();
        void  flush();
        bool  hasData();
        char* getData(int &size);

        void EndOfEvent();


        int check_attributes();
};

typedef struct
{
    daqpp_Module pyM;
    GenModule *md;
} vmedaq_Module;

#endif /*PYGENMODULE_H_*/
