#ifndef PYMODULE_PARSER_H_
#define PYMODULE_PARSER_H_

#include <Python.h>
#include <DAQ++/python/pydaqpp.h>
#include <gui/MonitorWindow.h>
#include <config/ModuleParser.h>



class pymodule_parser : public ModuleParser, public PyDAQpp
{
    public:
        pymodule_parser() {}
        ~pymodule_parser() {}

        void parse_node(xmlNodePtr node) throw (ConfigException);
        void save_config() throw(ConfigException);
        GtkWidget *config(const std::string &id);
        MonitorWindow *monitor(const std::string &id, const std::string &glade_file);

};

typedef struct
{
    PyObject_HEAD
    /* Type-specific fields go here. */
    PyObject    *dict;
    pymodule_parser *parser;
} vmedaq_module_parser;

#endif /*PYMODULE_PARSER_H_*/
