# sitelib for noarch packages, sitearch for others (remove the unneeded one)
%{!?python_sitelib: %define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
%{!?python_sitearch: %define python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}

Summary: DAQ program based on DAQ++ and gtkhst 
Name: vmedaq
Version: 1.0.0
Release: 1
License: GPL
Group: Development/Libraries
Source: %{name}-%{version}-%{release}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
Prefix: %{_prefix}
Docdir: %{_docdir}
Requires: DAQ++ >= 1.0.1 gtkhst >= 0.2.0 zlib
BuildRequires: DAQ++-devel >= 1.0.1 gtkhst-devel >= 0.2.0 zlib-devel python-devel


%description
DAQ program based on DAQ++ and gtkhst 

%package vmedaq-analysis
Summary: libraries to read vmedaq data
Group: Development/Libraries
Requires: zlib python >= 2.0
BuildRequires: zlib-devel python-devel >= 2.0

%description vmedaq-analysis
Set of libraries to read data from vmedaq. It provides interfaces in
c++, python and fortran

%prep
%setup -q -n %{name}-%{version}-%{release}

%build
%configure --disable-rpath

make %{?_smp_mflags}

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

#
# Make cleaned-up versions of tutorials, examples, and faq for installation
#
./scripts/mkinstalldirs tmpdocs
./scripts/mkinstalldirs tmpdocs/python
./scripts/mkinstalldirs tmpdocs/analysis
./scripts/mkinstalldirs tmpdocs/making_a_module

dir=making_a_module
file_list="\
config.xml UserMakefile README \
test_module.cc test_module.h \
test_module_conf.cc\
"
if [ -d $dir ] ; then
   ./scripts/mkinstalldirs tmpdocs/$dir
   for file in $file_list; do
      install -m 0644 $dir/$file tmpdocs/$dir
   done
   mv tmpdocs/$dir/UserMakefile tmpdocs/$dir/Makefile
fi

dir=python/corba
file_list="analysis/$dir/*.py analysis/$dir/*.glade"
if [ -d analysis/$dir ] ; then
   ./scripts/mkinstalldirs tmpdocs/$dir
   for file in $file_list; do
      install -m 0644 $file tmpdocs/$dir
   done
fi

dir=python/test
file_list="analysis/$dir/*.py"
if [ -d analysis/$dir ] ; then
   ./scripts/mkinstalldirs tmpdocs/$dir
   for file in $file_list; do
      install -m 0644 $file tmpdocs/$dir
   done
fi

dir=fortran
file_list="UserMakefile tstF.F Root.inc common_block.inc"
if [ -d analysis/$dir ] ; then
   ./scripts/mkinstalldirs tmpdocs/$dir
   for file in $file_list; do
      install -m 0644 analysis/fortran/$file tmpdocs/$dir
   done
   mv tmpdocs/$dir/UserMakefile tmpdocs/$dir/Makefile
fi

dir=analysis
file_list="tstlib.cc"
if [ -d analysis/$dir ] ; then
   ./scripts/mkinstalldirs tmpdocs/$dir
   for file in $file_list; do
      install -m 0644 analysis/analysis/$file tmpdocs/$dir
   done
fi

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-, root, root)

%doc AUTHORS ChangeLog COPYING NEWS README  
%doc tmpdocs/making_a_module 
%doc doc/graphics
%{_bindir}/dump_data
%{_bindir}/vmedaq
%{_bindir}/vata
%{_includedir}/vmedaq/config/*
%{_includedir}/vmedaq/daq/*
%{_includedir}/vmedaq/data/*
%{_includedir}/vmedaq/gui/*
%{_includedir}/vmedaq/vmedaq/*
%{_libdir}/libvmedaq*
%{_libdir}/vmedaq/*
%{_libdir}/pkgconfig/vmedaq-modules.pc
%{_datadir}/vmedaq/*
				   
%files vmedaq-analysis
%defattr(-, root, root)

%doc AUTHORS ChangeLog COPYING NEWS README  
%doc tmpdocs/python
%doc tmpdocs/analysis
%doc tmpdocs/fortran
%{_bindir}/spydata
%{_includedir}/vmedaq/analysis/*
%{_libdir}/libVMEdaq*
%{python_sitearch}/vmedaq/
%{_libdir}/pkgconfig/vmedaq-c++.pc
%{_libdir}/pkgconfig/vmedaq-f77.pc

